import ReactDOM from "react-dom";
import {
  compileMarkdownToReact,
  compileMarkdownToHTML
} from "../src"

// React
import ReactDOMServer from "react-dom/server";
const textarea = document.querySelector("textarea");
const preview = document.querySelector(".previewContainer");

textarea.value = `
# Markdown Preview Playground

line
break.

mention @mizchi
emoji :100:
math: $ \\int_0^\\infty x^2 dx $

## Codeblock

with filename

\`\`\`js:file.js
var x = 3;
\`\`\`
`

function render() {
  var start = Date.now();
  compileMarkdownToReact(textarea.value, {}, (err, ret) => {
    if (err) return console.warn(err);
    console.log("compile time:", Date.now() - start);
    ReactDOM.render(ret.contents, preview);
  });
}

// render();
compileMarkdownToHTML(textarea.value, {}, (err, ret) => {
  if (err) return console.warn(err);
  preview.innerHTML = `<div class="markdownContent">${ret.contents}</div>`;
});

textarea.addEventListener("input", () => {
  compileMarkdownToReact(textarea.value, {}, (err, ret) => {
    if (err) return console.warn(err);
    ReactDOM.render(ret.contents, preview);
  });
  render();
});
