"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.compileMarkdownToHTML = compileMarkdownToHTML;
exports.compileMarkdownToReact = compileMarkdownToReact;

var _vfileReporter = require("vfile-reporter");

var _vfileReporter2 = _interopRequireDefault(_vfileReporter);

var _mdastToHtml = require("./mdast-to-html");

var _mdastToHtml2 = _interopRequireDefault(_mdastToHtml);

var _mdastToReact = require("./mdast-to-react");

var _mdastToReact2 = _interopRequireDefault(_mdastToReact);

var _processor = require("./processor");

var _processor2 = _interopRequireDefault(_processor);

var _remarkOptions = require("./remark-options");

var _remarkOptions2 = _interopRequireDefault(_remarkOptions);

var _xtend = require("xtend");

var _xtend2 = _interopRequireDefault(_xtend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function compileMarkdownToHTML(md) {
  var opts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var callback = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

  return _processor2.default.use(_mdastToHtml2.default).process(md, (0, _xtend2.default)(_remarkOptions2.default, opts), callback);
}

function compileMarkdownToReact(md) {
  var opts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var callback = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

  return _processor2.default.use(_mdastToReact2.default).process(md, (0, _xtend2.default)(_remarkOptions2.default, opts), callback);
}