'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _katex = require('katex');

var _katex2 = _interopRequireDefault(_katex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var toHAST = require('@mizchi/mdast-util-to-hast');
var sanitize = require('hast-util-sanitize');
var toH = require('hast-to-hyperscript');
var React = require('react');
var own = {}.hasOwnProperty;
var TABLE_ELEMENTS = ['table', 'thead', 'tbody', 'tfoot', 'tr'];

var Math = function (_React$Component) {
  _inherits(Math, _React$Component);

  function Math() {
    _classCallCheck(this, Math);

    return _possibleConstructorReturn(this, (Math.__proto__ || Object.getPrototypeOf(Math)).apply(this, arguments));
  }

  _createClass(Math, [{
    key: 'update',
    value: function update() {
      var el = _reactDom2.default.findDOMNode(this);
      _katex2.default.render(this.props.value, el);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(old) {
      if (this.props.value !== old.value) {
        this.update();
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.update();
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement('span', { className: 'math-container' });
    }
  }]);

  return Math;
}(React.Component);

// import KaTeX from "react-katex";


module.exports = function plugin(processor, options) {
  var settings = options || {};
  Compiler.prototype.compile = compile;
  processor.Compiler = Compiler;

  function Compiler(file) {
    /* istanbul ignore if - vfile@1.0.0 */
    if (file.extension) {
      file.move({ extension: 'html' });
    }

    if (file.extname) {
      file.extname = '.html';
    }
  }

  function compile(node) {
    var components = settings.reactComponents || { Math: Math };
    function h(name, props, children) {
      var reactComponentName = props && props["data-react-component"];
      if (reactComponentName) {
        var component = components[reactComponentName];
        var reactProps = JSON.parse(props["data-react-props"]);
        // add key
        reactProps.key = props.key;
        return React.createElement(component, reactProps, children);
      } else {
        var component = name;
        if (children && TABLE_ELEMENTS.indexOf(component) !== -1) {
          children = children.filter(function (child) {
            return child !== '\n';
          });
        }
        return React.createElement(component, props, children);
      }
    }

    var clone = require('clone');
    var settingBase = require('hast-util-sanitize/lib/github.json');
    var schema = clone(settingBase);
    schema.attributes['*'].push('className');
    // var clean = sanitize({
    //   type: 'element',
    //   tagName: 'div',
    //   properties: {},
    //   children: toHAST(node).children
    // }, schema)
    var clean = {
      type: 'element',
      tagName: 'div',
      properties: {
        className: "markdownContent"
      },
      children: toHAST(node).children
    };
    return toH(h, clean, settings.prefix);
  }
};